/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.335 Revision 1.428
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.335 2010/02/26 05:17:24 halcy0n Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.428 2013/12/03 08:09:49 vapier Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18inherit multilib portability 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
19 20
20DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
21 22
22if has "${EAPI:-0}" 0 1 2; then 23if has "${EAPI:-0}" 0 1 2; then
23 24
24# @FUNCTION: epause 25# @FUNCTION: epause
25# @USAGE: [seconds] 26# @USAGE: [seconds]
52} 53}
53 54
54else 55else
55 56
56ebeep() { 57ebeep() {
57 [[ $(type -t eqawarn) == function ]] && \
58 eqawarn "QA Notice: ebeep is not defined in EAPI=3, please file a bug at http://bugs.gentoo.org" 58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59} 59}
60 60
61epause() { 61epause() {
62 [[ $(type -t eqawarn) == function ]] && \
63 eqawarn "QA Notice: epause is not defined in EAPI=3, please file a bug at http://bugs.gentoo.org" 62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
64} 63}
65 64
65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
66fi 78fi
67 79
68# @FUNCTION: ecvs_clean 80# @FUNCTION: ecvs_clean
69# @USAGE: [list of dirs] 81# @USAGE: [list of dirs]
70# @DESCRIPTION: 82# @DESCRIPTION:
84esvn_clean() { 96esvn_clean() {
85 [[ -z $* ]] && set -- . 97 [[ -z $* ]] && set -- .
86 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf 98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
87} 99}
88 100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: evar_push
150# @USAGE: <variable to save> [more vars to save]
151# @DESCRIPTION:
152# This let's you temporarily modify a variable and then restore it (including
153# set vs unset semantics). Arrays are not supported at this time.
154#
155# This is meant for variables where using `local` does not work (such as
156# exported variables, or only temporarily changing things in a func).
157#
158# For example:
159# @CODE
160# evar_push LC_ALL
161# export LC_ALL=C
162# ... do some stuff that needs LC_ALL=C set ...
163# evar_pop
164#
165# # You can also save/restore more than one var at a time
166# evar_push BUTTERFLY IN THE SKY
167# ... do stuff with the vars ...
168# evar_pop # This restores just one var, SKY
169# ... do more stuff ...
170# evar_pop 3 # This pops the remaining 3 vars
171# @CODE
172evar_push() {
173 local var val
174 for var ; do
175 [[ ${!var+set} == "set" ]] \
176 && val=${!var} \
177 || val="${___ECLASS_ONCE_EUTILS}"
178 estack_push evar "${var}" "${val}"
179 done
180}
181
182# @FUNCTION: evar_push_set
183# @USAGE: <variable to save> [new value to store]
184# @DESCRIPTION:
185# This is a handy shortcut to save and temporarily set a variable. If a value
186# is not specified, the var will be unset.
187evar_push_set() {
188 local var=$1
189 evar_push ${var}
190 case $# in
191 1) unset ${var} ;;
192 2) printf -v "${var}" '%s' "$2" ;;
193 *) die "${FUNCNAME}: incorrect # of args: $*" ;;
194 esac
195}
196
197# @FUNCTION: evar_pop
198# @USAGE: [number of vars to restore]
199# @DESCRIPTION:
200# Restore the variables to the state saved with the corresponding
201# evar_push call. See that function for more details.
202evar_pop() {
203 local cnt=${1:-bad}
204 case $# in
205 0) cnt=1 ;;
206 1) isdigit "${cnt}" || die "${FUNCNAME}: first arg must be a number: $*" ;;
207 *) die "${FUNCNAME}: only accepts one arg: $*" ;;
208 esac
209
210 local var val
211 while (( cnt-- )) ; do
212 estack_pop evar val || die "${FUNCNAME}: unbalanced push"
213 estack_pop evar var || die "${FUNCNAME}: unbalanced push"
214 [[ ${val} == "${___ECLASS_ONCE_EUTILS}" ]] \
215 && unset ${var} \
216 || printf -v "${var}" '%s' "${val}"
217 done
218}
219
89# @FUNCTION: eshopts_push 220# @FUNCTION: eshopts_push
90# @USAGE: [options to `set` or `shopt`] 221# @USAGE: [options to `set` or `shopt`]
91# @DESCRIPTION: 222# @DESCRIPTION:
92# Often times code will want to enable a shell option to change code behavior. 223# Often times code will want to enable a shell option to change code behavior.
93# Since changing shell options can easily break other pieces of code (which 224# Since changing shell options can easily break other pieces of code (which
98# rather than `set` as there are some options only available via that. 229# rather than `set` as there are some options only available via that.
99# 230#
100# A common example is to disable shell globbing so that special meaning/care 231# A common example is to disable shell globbing so that special meaning/care
101# may be used with variables/arguments to custom functions. That would be: 232# may be used with variables/arguments to custom functions. That would be:
102# @CODE 233# @CODE
103# eshopts_push -o noglob 234# eshopts_push -s noglob
104# for x in ${foo} ; do 235# for x in ${foo} ; do
105# if ...some check... ; then 236# if ...some check... ; then
106# eshopts_pop 237# eshopts_pop
107# return 0 238# return 0
108# fi 239# fi
109# done 240# done
110# eshopts_pop 241# eshopts_pop
111# @CODE 242# @CODE
112eshopts_push() { 243eshopts_push() {
113 # have to assume __ESHOPTS_SAVE__ isn't screwed with
114 # as a `declare -a` here will reset its value
115 local i=${#__ESHOPTS_SAVE__[@]}
116 if [[ $1 == -[su] ]] ; then 244 if [[ $1 == -[su] ]] ; then
117 __ESHOPTS_SAVE__[$i]=$(shopt -p) 245 estack_push eshopts "$(shopt -p)"
118 [[ $# -eq 0 ]] && return 0 246 [[ $# -eq 0 ]] && return 0
119 shopt "$@" || die "eshopts_push: bad options to shopt: $*" 247 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
120 else 248 else
121 __ESHOPTS_SAVE__[$i]=$- 249 estack_push eshopts $-
122 [[ $# -eq 0 ]] && return 0 250 [[ $# -eq 0 ]] && return 0
123 set "$@" || die "eshopts_push: bad options to set: $*" 251 set "$@" || die "${FUNCNAME}: bad options to set: $*"
124 fi 252 fi
125} 253}
126 254
127# @FUNCTION: eshopts_pop 255# @FUNCTION: eshopts_pop
128# @USAGE: 256# @USAGE:
129# @DESCRIPTION: 257# @DESCRIPTION:
130# Restore the shell options to the state saved with the corresponding 258# Restore the shell options to the state saved with the corresponding
131# eshopts_push call. See that function for more details. 259# eshopts_push call. See that function for more details.
132eshopts_pop() { 260eshopts_pop() {
133 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments" 261 local s
134 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 )) 262 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
135 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
136 local s=${__ESHOPTS_SAVE__[$i]}
137 unset __ESHOPTS_SAVE__[$i]
138 if [[ ${s} == "shopt -"* ]] ; then 263 if [[ ${s} == "shopt -"* ]] ; then
139 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}" 264 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
140 else 265 else
141 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-" 266 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
142 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}" 267 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
143 fi 268 fi
269}
270
271# @FUNCTION: eumask_push
272# @USAGE: <new umask>
273# @DESCRIPTION:
274# Set the umask to the new value specified while saving the previous
275# value onto a stack. Useful for temporarily changing the umask.
276eumask_push() {
277 estack_push eumask "$(umask)"
278 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
279}
280
281# @FUNCTION: eumask_pop
282# @USAGE:
283# @DESCRIPTION:
284# Restore the previous umask state.
285eumask_pop() {
286 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
287 local s
288 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
289 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
290}
291
292# @FUNCTION: isdigit
293# @USAGE: <number> [more numbers]
294# @DESCRIPTION:
295# Return true if all arguments are numbers.
296isdigit() {
297 local d
298 for d ; do
299 [[ ${d:-bad} == *[!0-9]* ]] && return 1
300 done
301 return 0
144} 302}
145 303
146# @VARIABLE: EPATCH_SOURCE 304# @VARIABLE: EPATCH_SOURCE
147# @DESCRIPTION: 305# @DESCRIPTION:
148# Default directory to search for patches. 306# Default directory to search for patches.
151# @DESCRIPTION: 309# @DESCRIPTION:
152# Default extension for patches (do not prefix the period yourself). 310# Default extension for patches (do not prefix the period yourself).
153EPATCH_SUFFIX="patch.bz2" 311EPATCH_SUFFIX="patch.bz2"
154# @VARIABLE: EPATCH_OPTS 312# @VARIABLE: EPATCH_OPTS
155# @DESCRIPTION: 313# @DESCRIPTION:
156# Default options for patch: 314# Options to pass to patch. Meant for ebuild/package-specific tweaking
315# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
316# for single patch tweaking, you can also pass flags directly to epatch.
317EPATCH_OPTS=""
318# @VARIABLE: EPATCH_COMMON_OPTS
319# @DESCRIPTION:
320# Common options to pass to `patch`. You probably should never need to
321# change these. If you do, please discuss it with base-system first to
322# be sure.
157# @CODE 323# @CODE
158# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571 324# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
159# --no-backup-if-mismatch - do not leave .orig files behind 325# --no-backup-if-mismatch - do not leave .orig files behind
160# -E - automatically remove empty files 326# -E - automatically remove empty files
161# @CODE 327# @CODE
162EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 328EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
163# @VARIABLE: EPATCH_EXCLUDE 329# @VARIABLE: EPATCH_EXCLUDE
164# @DESCRIPTION: 330# @DESCRIPTION:
165# List of patches not to apply. Note this is only file names, 331# List of patches not to apply. Note this is only file names,
166# and not the full path. Globs accepted. 332# and not the full path. Globs accepted.
167EPATCH_EXCLUDE="" 333EPATCH_EXCLUDE=""
176# @VARIABLE: EPATCH_FORCE 342# @VARIABLE: EPATCH_FORCE
177# @DESCRIPTION: 343# @DESCRIPTION:
178# Only require patches to match EPATCH_SUFFIX rather than the extended 344# Only require patches to match EPATCH_SUFFIX rather than the extended
179# arch naming style. 345# arch naming style.
180EPATCH_FORCE="no" 346EPATCH_FORCE="no"
347# @VARIABLE: EPATCH_USER_EXCLUDE
348# @DEFAULT_UNSET
349# @DESCRIPTION:
350# List of patches not to apply. Note this is only file names,
351# and not the full path. Globs accepted.
181 352
182# @FUNCTION: epatch 353# @FUNCTION: epatch
183# @USAGE: [patches] [dirs of patches] 354# @USAGE: [options] [patches] [dirs of patches]
184# @DESCRIPTION: 355# @DESCRIPTION:
185# epatch is designed to greatly simplify the application of patches. It can 356# epatch is designed to greatly simplify the application of patches. It can
186# process patch files directly, or directories of patches. The patches may be 357# process patch files directly, or directories of patches. The patches may be
187# compressed (bzip/gzip/etc...) or plain text. You generally need not specify 358# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
188# the -p option as epatch will automatically attempt -p0 to -p5 until things 359# the -p option as epatch will automatically attempt -p0 to -p4 until things
189# apply successfully. 360# apply successfully.
190# 361#
191# If you do not specify any options, then epatch will default to the directory 362# If you do not specify any patches/dirs, then epatch will default to the
192# specified by EPATCH_SOURCE. 363# directory specified by EPATCH_SOURCE.
364#
365# Any options specified that start with a dash will be passed down to patch
366# for this specific invocation. As soon as an arg w/out a dash is found, then
367# arg processing stops.
193# 368#
194# When processing directories, epatch will apply all patches that match: 369# When processing directories, epatch will apply all patches that match:
195# @CODE 370# @CODE
196# ${EPATCH_FORCE} == "yes" 371# if ${EPATCH_FORCE} != "yes"
197# ??_${ARCH}_foo.${EPATCH_SUFFIX} 372# ??_${ARCH}_foo.${EPATCH_SUFFIX}
198# else 373# else
199# *.${EPATCH_SUFFIX} 374# *.${EPATCH_SUFFIX}
200# @CODE 375# @CODE
201# The leading ?? are typically numbers used to force consistent patch ordering. 376# The leading ?? are typically numbers used to force consistent patch ordering.
215 echo "${1//?/=}" 390 echo "${1//?/=}"
216 } 391 }
217 392
218 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 393 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
219 394
395 # First process options. We localize the EPATCH_OPTS setting
396 # from above so that we can pass it on in the loop below with
397 # any additional values the user has specified.
398 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
399 while [[ $# -gt 0 ]] ; do
400 case $1 in
401 -*) EPATCH_OPTS+=( "$1" ) ;;
402 *) break ;;
403 esac
404 shift
405 done
406
220 # Let the rest of the code process one user arg at a time -- 407 # Let the rest of the code process one user arg at a time --
221 # each arg may expand into multiple patches, and each arg may 408 # each arg may expand into multiple patches, and each arg may
222 # need to start off with the default global EPATCH_xxx values 409 # need to start off with the default global EPATCH_xxx values
223 if [[ $# -gt 1 ]] ; then 410 if [[ $# -gt 1 ]] ; then
224 local m 411 local m
238 # Use the suffix from the single patch (localize it); the code 425 # Use the suffix from the single patch (localize it); the code
239 # below will find the suffix for us 426 # below will find the suffix for us
240 local EPATCH_SUFFIX=$1 427 local EPATCH_SUFFIX=$1
241 428
242 elif [[ -d $1 ]] ; then 429 elif [[ -d $1 ]] ; then
430 # We have to force sorting to C so that the wildcard expansion is consistent #471666.
431 evar_push_set LC_COLLATE C
243 # Some people like to make dirs of patches w/out suffixes (vim) 432 # Some people like to make dirs of patches w/out suffixes (vim).
244 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"} 433 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
434 evar_pop
435
436 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
437 # Re-use EPATCH_SOURCE as a search dir
438 epatch "${EPATCH_SOURCE}/$1"
439 return $?
245 440
246 else 441 else
247 # sanity check ... if it isn't a dir or file, wtf man ? 442 # sanity check ... if it isn't a dir or file, wtf man ?
248 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1 443 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
249 echo 444 echo
253 eerror " ( ${EPATCH_SOURCE##*/} )" 448 eerror " ( ${EPATCH_SOURCE##*/} )"
254 echo 449 echo
255 die "Cannot find \$EPATCH_SOURCE!" 450 die "Cannot find \$EPATCH_SOURCE!"
256 fi 451 fi
257 452
453 # Now that we know we're actually going to apply something, merge
454 # all of the patch options back in to a single variable for below.
455 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
456
258 local PIPE_CMD 457 local PIPE_CMD
259 case ${EPATCH_SUFFIX##*\.} in 458 case ${EPATCH_SUFFIX##*\.} in
260 xz) PIPE_CMD="xz -dc" ;; 459 xz) PIPE_CMD="xz -dc" ;;
261 lzma) PIPE_CMD="lzma -dc" ;; 460 lzma) PIPE_CMD="lzma -dc" ;;
262 bz2) PIPE_CMD="bzip2 -dc" ;; 461 bz2) PIPE_CMD="bzip2 -dc" ;;
280 # ???_arch_foo.patch 479 # ???_arch_foo.patch
281 # Else, skip this input altogether 480 # Else, skip this input altogether
282 local a=${patchname#*_} # strip the ???_ 481 local a=${patchname#*_} # strip the ???_
283 a=${a%%_*} # strip the _foo.patch 482 a=${a%%_*} # strip the _foo.patch
284 if ! [[ ${SINGLE_PATCH} == "yes" || \ 483 if ! [[ ${SINGLE_PATCH} == "yes" || \
285 ${EPATCH_FORCE} == "yes" || \ 484 ${EPATCH_FORCE} == "yes" || \
286 ${a} == all || \ 485 ${a} == all || \
287 ${a} == ${ARCH} ]] 486 ${a} == ${ARCH} ]]
288 then 487 then
289 continue 488 continue
290 fi 489 fi
291 490
292 # Let people filter things dynamically 491 # Let people filter things dynamically
295 eshopts_push -o noglob 494 eshopts_push -o noglob
296 495
297 local ex 496 local ex
298 for ex in ${EPATCH_EXCLUDE} ; do 497 for ex in ${EPATCH_EXCLUDE} ; do
299 if [[ ${patchname} == ${ex} ]] ; then 498 if [[ ${patchname} == ${ex} ]] ; then
499 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
500 eshopts_pop
501 continue 2
502 fi
503 done
504
505 for ex in ${EPATCH_USER_EXCLUDE} ; do
506 if [[ ${patchname} == ${ex} ]] ; then
507 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
300 eshopts_pop 508 eshopts_pop
301 continue 2 509 continue 2
302 fi 510 fi
303 done 511 done
304 512
320 local STDERR_TARGET="${T}/${patchname}.out" 528 local STDERR_TARGET="${T}/${patchname}.out"
321 if [[ -e ${STDERR_TARGET} ]] ; then 529 if [[ -e ${STDERR_TARGET} ]] ; then
322 STDERR_TARGET="${T}/${patchname}-$$.out" 530 STDERR_TARGET="${T}/${patchname}-$$.out"
323 fi 531 fi
324 532
325 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}" 533 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
326 534
327 # Decompress the patch if need be 535 # Decompress the patch if need be
328 local count=0 536 local count=0
329 local PATCH_TARGET 537 local PATCH_TARGET
330 if [[ -n ${PIPE_CMD} ]] ; then 538 if [[ -n ${PIPE_CMD} ]] ; then
349 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }') 557 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
350 if [[ -n ${abs_paths} ]] ; then 558 if [[ -n ${abs_paths} ]] ; then
351 count=1 559 count=1
352 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}" 560 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
353 fi 561 fi
562 # Similar reason, but with relative paths.
563 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
564 if [[ -n ${rel_paths} ]] ; then
565 echo
566 eerror "Rejected Patch: ${patchname} !"
567 eerror " ( ${PATCH_TARGET} )"
568 eerror
569 eerror "Your patch uses relative paths '../':"
570 eerror "${rel_paths}"
571 echo
572 die "you need to fix the relative paths in patch"
573 fi
354 574
355 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/ 575 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
576 local patch_cmd
577 # Handle aliased patch command #404447 #461568
578 local patch="patch"
579 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
356 while [[ ${count} -lt 5 ]] ; do 580 while [[ ${count} -lt 5 ]] ; do
581 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
582
357 # Generate some useful debug info ... 583 # Generate some useful debug info ...
358 ( 584 (
359 _epatch_draw_line "***** ${patchname} *****" 585 _epatch_draw_line "***** ${patchname} *****"
360 echo 586 echo
361 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'" 587 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
362 echo 588 echo
363 _epatch_draw_line "***** ${patchname} *****" 589 _epatch_draw_line "***** ${patchname} *****"
590 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
591 ret=$?
592 echo
593 echo "patch program exited with status ${ret}"
594 exit ${ret}
364 ) >> "${STDERR_TARGET}" 595 ) >> "${STDERR_TARGET}"
365 596
366 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then 597 if [ $? -eq 0 ] ; then
367 ( 598 (
368 _epatch_draw_line "***** ${patchname} *****" 599 _epatch_draw_line "***** ${patchname} *****"
369 echo 600 echo
370 echo "ACTUALLY APPLYING ${patchname} ..." 601 echo "ACTUALLY APPLYING ${patchname} ..."
371 echo 602 echo
372 _epatch_draw_line "***** ${patchname} *****" 603 _epatch_draw_line "***** ${patchname} *****"
373 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1 604 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
605 ret=$?
606 echo
607 echo "patch program exited with status ${ret}"
608 exit ${ret}
374 ) >> "${STDERR_TARGET}" 609 ) >> "${STDERR_TARGET}"
375 610
376 if [ $? -ne 0 ] ; then 611 if [ $? -ne 0 ] ; then
377 echo 612 echo
378 eerror "A dry-run of patch command succeeded, but actually" 613 eerror "A dry-run of patch command succeeded, but actually"
401 eerror " ${STDERR_TARGET}" 636 eerror " ${STDERR_TARGET}"
402 echo 637 echo
403 die "Failed Patch: ${patchname}!" 638 die "Failed Patch: ${patchname}!"
404 fi 639 fi
405 640
406 # if everything worked, delete the patch log 641 # if everything worked, delete the full debug patch log
407 rm -f "${STDERR_TARGET}" 642 rm -f "${STDERR_TARGET}"
643
644 # then log away the exact stuff for people to review later
645 cat <<-EOF >> "${T}/epatch.log"
646 PATCH: ${x}
647 CMD: ${patch_cmd}
648 PWD: ${PWD}
649
650 EOF
408 eend 0 651 eend 0
409 done 652 done
410 653
411 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching" 654 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
412 : # everything worked 655 : # everything worked
413} 656}
657
658# @FUNCTION: epatch_user
659# @USAGE:
660# @DESCRIPTION:
661# Applies user-provided patches to the source tree. The patches are
662# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
663# of these three directories to exist will be the one to use, ignoring
664# any more general directories which might exist as well. They must end
665# in ".patch" to be applied.
666#
667# User patches are intended for quick testing of patches without ebuild
668# modifications, as well as for permanent customizations a user might
669# desire. Obviously, there can be no official support for arbitrarily
670# patched ebuilds. So whenever a build log in a bug report mentions that
671# user patches were applied, the user should be asked to reproduce the
672# problem without these.
673#
674# Not all ebuilds do call this function, so placing patches in the
675# stated directory might or might not work, depending on the package and
676# the eclasses it inherits and uses. It is safe to call the function
677# repeatedly, so it is always possible to add a call at the ebuild
678# level. The first call is the time when the patches will be
679# applied.
680#
681# Ideally, this function should be called after gentoo-specific patches
682# have been applied, so that their code can be modified as well, but
683# before calls to e.g. eautoreconf, as the user patches might affect
684# autotool input files as well.
414epatch_user() { 685epatch_user() {
415 [[ $# -ne 0 ]] && die "epatch_user takes no options" 686 [[ $# -ne 0 ]] && die "epatch_user takes no options"
416 687
688 # Allow multiple calls to this function; ignore all but the first
689 local applied="${T}/epatch_user.log"
690 [[ -e ${applied} ]] && return 2
691
417 # don't clobber any EPATCH vars that the parent might want 692 # don't clobber any EPATCH vars that the parent might want
418 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches 693 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
419 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do 694 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
420 EPATCH_SOURCE=${base}/${CTARGET}/${check} 695 EPATCH_SOURCE=${base}/${CTARGET}/${check}
421 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check} 696 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
422 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check} 697 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
423 if [[ -d ${EPATCH_SOURCE} ]] ; then 698 if [[ -d ${EPATCH_SOURCE} ]] ; then
424 EPATCH_SOURCE=${EPATCH_SOURCE} \ 699 EPATCH_SOURCE=${EPATCH_SOURCE} \
425 EPATCH_SUFFIX="patch" \ 700 EPATCH_SUFFIX="patch" \
426 EPATCH_FORCE="yes" \ 701 EPATCH_FORCE="yes" \
427 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \ 702 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
428 epatch 703 epatch
429 break 704 echo "${EPATCH_SOURCE}" > "${applied}"
705 return 0
430 fi 706 fi
431 done 707 done
708 echo "none" > "${applied}"
709 return 1
432} 710}
433 711
434# @FUNCTION: emktemp 712# @FUNCTION: emktemp
435# @USAGE: [temp dir] 713# @USAGE: [temp dir]
436# @DESCRIPTION: 714# @DESCRIPTION:
464 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 742 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
465 fi 743 fi
466 fi 744 fi
467} 745}
468 746
469# @FUNCTION: egetent
470# @USAGE: <database> <key>
471# @MAINTAINER:
472# base-system@gentoo.org (Linux)
473# Joe Jezak <josejx@gmail.com> (OS X)
474# usata@gentoo.org (OS X)
475# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
476# @DESCRIPTION:
477# Small wrapper for getent (Linux),
478# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
479# and pw (FreeBSD) used in enewuser()/enewgroup()
480egetent() {
481 case ${CHOST} in
482 *-darwin[678])
483 case "$2" in
484 *[!0-9]*) # Non numeric
485 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
486 ;;
487 *) # Numeric
488 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
489 ;;
490 esac
491 ;;
492 *-darwin*)
493 local mytype=$1
494 [[ "passwd" == $mytype ]] && mytype="Users"
495 [[ "group" == $mytype ]] && mytype="Groups"
496 case "$2" in
497 *[!0-9]*) # Non numeric
498 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
499 ;;
500 *) # Numeric
501 local mykey="UniqueID"
502 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
503 dscl . -search /$mytype $mykey $2 2>/dev/null
504 ;;
505 esac
506 ;;
507 *-freebsd*|*-dragonfly*)
508 local opts action="user"
509 [[ $1 == "passwd" ]] || action="group"
510
511 # lookup by uid/gid
512 if [[ $2 == [[:digit:]]* ]] ; then
513 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
514 fi
515
516 pw show ${action} ${opts} "$2" -q
517 ;;
518 *-netbsd*|*-openbsd*)
519 grep "$2:\*:" /etc/$1
520 ;;
521 *)
522 type -p nscd >& /dev/null && nscd -i "$1"
523 getent "$1" "$2"
524 ;;
525 esac
526}
527
528# @FUNCTION: enewuser
529# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
530# @DESCRIPTION:
531# Same as enewgroup, you are not required to understand how to properly add
532# a user to the system. The only required parameter is the username.
533# Default uid is (pass -1 for this) next available, default shell is
534# /bin/false, default homedir is /dev/null, there are no default groups,
535# and default params sets the comment as 'added by portage for ${PN}'.
536enewuser() {
537 case ${EBUILD_PHASE} in
538 unpack|compile|test|install)
539 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
540 eerror "Package fails at QA and at life. Please file a bug."
541 die "Bad package! enewuser is only for use in pkg_* functions!"
542 esac
543
544 # get the username
545 local euser=$1; shift
546 if [[ -z ${euser} ]] ; then
547 eerror "No username specified !"
548 die "Cannot call enewuser without a username"
549 fi
550
551 # lets see if the username already exists
552 if [[ -n $(egetent passwd "${euser}") ]] ; then
553 return 0
554 fi
555 einfo "Adding user '${euser}' to your system ..."
556
557 # options to pass to useradd
558 local opts=
559
560 # handle uid
561 local euid=$1; shift
562 if [[ -n ${euid} && ${euid} != -1 ]] ; then
563 if [[ ${euid} -gt 0 ]] ; then
564 if [[ -n $(egetent passwd ${euid}) ]] ; then
565 euid="next"
566 fi
567 else
568 eerror "Userid given but is not greater than 0 !"
569 die "${euid} is not a valid UID"
570 fi
571 else
572 euid="next"
573 fi
574 if [[ ${euid} == "next" ]] ; then
575 for ((euid = 101; euid <= 999; euid++)); do
576 [[ -z $(egetent passwd ${euid}) ]] && break
577 done
578 fi
579 opts="${opts} -u ${euid}"
580 einfo " - Userid: ${euid}"
581
582 # handle shell
583 local eshell=$1; shift
584 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
585 if [[ ! -e ${ROOT}${eshell} ]] ; then
586 eerror "A shell was specified but it does not exist !"
587 die "${eshell} does not exist in ${ROOT}"
588 fi
589 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
590 eerror "Do not specify ${eshell} yourself, use -1"
591 die "Pass '-1' as the shell parameter"
592 fi
593 else
594 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
595 [[ -x ${ROOT}${shell} ]] && break
596 done
597
598 if [[ ${shell} == "/dev/null" ]] ; then
599 eerror "Unable to identify the shell to use, proceeding with userland default."
600 case ${USERLAND} in
601 GNU) shell="/bin/false" ;;
602 BSD) shell="/sbin/nologin" ;;
603 Darwin) shell="/usr/sbin/nologin" ;;
604 *) die "Unable to identify the default shell for userland ${USERLAND}"
605 esac
606 fi
607
608 eshell=${shell}
609 fi
610 einfo " - Shell: ${eshell}"
611 opts="${opts} -s ${eshell}"
612
613 # handle homedir
614 local ehome=$1; shift
615 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
616 ehome="/dev/null"
617 fi
618 einfo " - Home: ${ehome}"
619 opts="${opts} -d ${ehome}"
620
621 # handle groups
622 local egroups=$1; shift
623 if [[ ! -z ${egroups} ]] ; then
624 local oldifs=${IFS}
625 local defgroup="" exgroups=""
626
627 export IFS=","
628 for g in ${egroups} ; do
629 export IFS=${oldifs}
630 if [[ -z $(egetent group "${g}") ]] ; then
631 eerror "You must add group ${g} to the system first"
632 die "${g} is not a valid GID"
633 fi
634 if [[ -z ${defgroup} ]] ; then
635 defgroup=${g}
636 else
637 exgroups="${exgroups},${g}"
638 fi
639 export IFS=","
640 done
641 export IFS=${oldifs}
642
643 opts="${opts} -g ${defgroup}"
644 if [[ ! -z ${exgroups} ]] ; then
645 opts="${opts} -G ${exgroups:1}"
646 fi
647 else
648 egroups="(none)"
649 fi
650 einfo " - Groups: ${egroups}"
651
652 # handle extra and add the user
653 local oldsandbox=${SANDBOX_ON}
654 export SANDBOX_ON="0"
655 case ${CHOST} in
656 *-darwin*)
657 ### Make the user
658 if [[ -z $@ ]] ; then
659 dscl . create /users/${euser} uid ${euid}
660 dscl . create /users/${euser} shell ${eshell}
661 dscl . create /users/${euser} home ${ehome}
662 dscl . create /users/${euser} realname "added by portage for ${PN}"
663 ### Add the user to the groups specified
664 local oldifs=${IFS}
665 export IFS=","
666 for g in ${egroups} ; do
667 dscl . merge /groups/${g} users ${euser}
668 done
669 export IFS=${oldifs}
670 else
671 einfo "Extra options are not supported on Darwin yet"
672 einfo "Please report the ebuild along with the info below"
673 einfo "eextra: $@"
674 die "Required function missing"
675 fi
676 ;;
677 *-freebsd*|*-dragonfly*)
678 if [[ -z $@ ]] ; then
679 pw useradd ${euser} ${opts} \
680 -c "added by portage for ${PN}" \
681 die "enewuser failed"
682 else
683 einfo " - Extra: $@"
684 pw useradd ${euser} ${opts} \
685 "$@" || die "enewuser failed"
686 fi
687 ;;
688
689 *-netbsd*)
690 if [[ -z $@ ]] ; then
691 useradd ${opts} ${euser} || die "enewuser failed"
692 else
693 einfo " - Extra: $@"
694 useradd ${opts} ${euser} "$@" || die "enewuser failed"
695 fi
696 ;;
697
698 *-openbsd*)
699 if [[ -z $@ ]] ; then
700 useradd -u ${euid} -s ${eshell} \
701 -d ${ehome} -c "Added by portage for ${PN}" \
702 -g ${egroups} ${euser} || die "enewuser failed"
703 else
704 einfo " - Extra: $@"
705 useradd -u ${euid} -s ${eshell} \
706 -d ${ehome} -c "Added by portage for ${PN}" \
707 -g ${egroups} ${euser} "$@" || die "enewuser failed"
708 fi
709 ;;
710
711 *)
712 if [[ -z $@ ]] ; then
713 useradd ${opts} \
714 -c "added by portage for ${PN}" \
715 ${euser} \
716 || die "enewuser failed"
717 else
718 einfo " - Extra: $@"
719 useradd ${opts} "$@" \
720 ${euser} \
721 || die "enewuser failed"
722 fi
723 ;;
724 esac
725
726 if [[ ! -e ${ROOT}/${ehome} ]] ; then
727 einfo " - Creating ${ehome} in ${ROOT}"
728 mkdir -p "${ROOT}/${ehome}"
729 chown ${euser} "${ROOT}/${ehome}"
730 chmod 755 "${ROOT}/${ehome}"
731 fi
732
733 export SANDBOX_ON=${oldsandbox}
734}
735
736# @FUNCTION: enewgroup
737# @USAGE: <group> [gid]
738# @DESCRIPTION:
739# This function does not require you to understand how to properly add a
740# group to the system. Just give it a group name to add and enewgroup will
741# do the rest. You may specify the gid for the group or allow the group to
742# allocate the next available one.
743enewgroup() {
744 case ${EBUILD_PHASE} in
745 unpack|compile|test|install)
746 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
747 eerror "Package fails at QA and at life. Please file a bug."
748 die "Bad package! enewgroup is only for use in pkg_* functions!"
749 esac
750
751 # get the group
752 local egroup="$1"; shift
753 if [ -z "${egroup}" ]
754 then
755 eerror "No group specified !"
756 die "Cannot call enewgroup without a group"
757 fi
758
759 # see if group already exists
760 if [[ -n $(egetent group "${egroup}") ]]; then
761 return 0
762 fi
763 einfo "Adding group '${egroup}' to your system ..."
764
765 # options to pass to useradd
766 local opts=
767
768 # handle gid
769 local egid="$1"; shift
770 if [ ! -z "${egid}" ]
771 then
772 if [ "${egid}" -gt 0 ]
773 then
774 if [ -z "`egetent group ${egid}`" ]
775 then
776 if [[ "${CHOST}" == *-darwin* ]]; then
777 opts="${opts} ${egid}"
778 else
779 opts="${opts} -g ${egid}"
780 fi
781 else
782 egid="next available; requested gid taken"
783 fi
784 else
785 eerror "Groupid given but is not greater than 0 !"
786 die "${egid} is not a valid GID"
787 fi
788 else
789 egid="next available"
790 fi
791 einfo " - Groupid: ${egid}"
792
793 # handle extra
794 local eextra="$@"
795 opts="${opts} ${eextra}"
796
797 # add the group
798 local oldsandbox="${SANDBOX_ON}"
799 export SANDBOX_ON="0"
800 case ${CHOST} in
801 *-darwin*)
802 if [ ! -z "${eextra}" ];
803 then
804 einfo "Extra options are not supported on Darwin/OS X yet"
805 einfo "Please report the ebuild along with the info below"
806 einfo "eextra: ${eextra}"
807 die "Required function missing"
808 fi
809
810 # If we need the next available
811 case ${egid} in
812 *[!0-9]*) # Non numeric
813 for ((egid = 101; egid <= 999; egid++)); do
814 [[ -z $(egetent group ${egid}) ]] && break
815 done
816 esac
817 dscl . create /groups/${egroup} gid ${egid}
818 dscl . create /groups/${egroup} passwd '*'
819 ;;
820
821 *-freebsd*|*-dragonfly*)
822 case ${egid} in
823 *[!0-9]*) # Non numeric
824 for ((egid = 101; egid <= 999; egid++)); do
825 [[ -z $(egetent group ${egid}) ]] && break
826 done
827 esac
828 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
829 ;;
830
831 *-netbsd*)
832 case ${egid} in
833 *[!0-9]*) # Non numeric
834 for ((egid = 101; egid <= 999; egid++)); do
835 [[ -z $(egetent group ${egid}) ]] && break
836 done
837 esac
838 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
839 ;;
840
841 *)
842 groupadd ${opts} ${egroup} || die "enewgroup failed"
843 ;;
844 esac
845 export SANDBOX_ON="${oldsandbox}"
846}
847
848# @FUNCTION: edos2unix 747# @FUNCTION: edos2unix
849# @USAGE: <file> [more files ...] 748# @USAGE: <file> [more files ...]
850# @DESCRIPTION: 749# @DESCRIPTION:
851# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 750# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
852# to remove all of these text utilities from DEPEND variables because this 751# to remove all of these text utilities from DEPEND variables because this
853# is a script based solution. Just give it a list of files to convert and 752# is a script based solution. Just give it a list of files to convert and
854# they will all be changed from the DOS CRLF format to the UNIX LF format. 753# they will all be changed from the DOS CRLF format to the UNIX LF format.
855edos2unix() { 754edos2unix() {
856 echo "$@" | xargs sed -i 's/\r$//' 755 [[ $# -eq 0 ]] && return 0
756 sed -i 's/\r$//' -- "$@" || die
857} 757}
858 758
759# @FUNCTION: make_desktop_entry
760# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
761# @DESCRIPTION:
859# Make a desktop file ! 762# Make a .desktop file.
860# Great for making those icons in kde/gnome startmenu !
861# Amaze your friends ! Get the women ! Join today !
862# 763#
863# make_desktop_entry(<command>, [name], [icon], [type], [path]) 764# @CODE
864#
865# binary: what command does the app run with ? 765# binary: what command does the app run with ?
866# name: the name that will show up in the menu 766# name: the name that will show up in the menu
867# icon: give your little like a pretty little icon ... 767# icon: the icon to use in the menu entry
868# this can be relative (to /usr/share/pixmaps) or 768# this can be relative (to /usr/share/pixmaps) or
869# a full path to an icon 769# a full path to an icon
870# type: what kind of application is this ? for categories: 770# type: what kind of application is this?
771# for categories:
871# http://standards.freedesktop.org/menu-spec/latest/apa.html 772# http://standards.freedesktop.org/menu-spec/latest/apa.html
872# path: if your app needs to startup in a specific dir 773# if unset, function tries to guess from package's category
774# fields: extra fields to append to the desktop file; a printf string
775# @CODE
873make_desktop_entry() { 776make_desktop_entry() {
874 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 777 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
875 778
876 local exec=${1} 779 local exec=${1}
877 local name=${2:-${PN}} 780 local name=${2:-${PN}}
878 local icon=${3:-${PN}} 781 local icon=${3:-${PN}}
879 local type=${4} 782 local type=${4}
880 local path=${5} 783 local fields=${5}
881 784
882 if [[ -z ${type} ]] ; then 785 if [[ -z ${type} ]] ; then
883 local catmaj=${CATEGORY%%-*} 786 local catmaj=${CATEGORY%%-*}
884 local catmin=${CATEGORY##*-} 787 local catmin=${CATEGORY##*-}
885 case ${catmaj} in 788 case ${catmaj} in
886 app) 789 app)
887 case ${catmin} in 790 case ${catmin} in
888 accessibility) type=Accessibility;; 791 accessibility) type="Utility;Accessibility";;
889 admin) type=System;; 792 admin) type=System;;
890 antivirus) type=System;; 793 antivirus) type=System;;
891 arch) type=Archiving;; 794 arch) type="Utility;Archiving";;
892 backup) type=Archiving;; 795 backup) type="Utility;Archiving";;
893 cdr) type=DiscBurning;; 796 cdr) type="AudioVideo;DiscBurning";;
894 dicts) type=Dictionary;; 797 dicts) type="Office;Dictionary";;
895 doc) type=Documentation;; 798 doc) type=Documentation;;
896 editors) type=TextEditor;; 799 editors) type="Utility;TextEditor";;
897 emacs) type=TextEditor;; 800 emacs) type="Development;TextEditor";;
898 emulation) type=Emulator;; 801 emulation) type="System;Emulator";;
899 laptop) type=HardwareSettings;; 802 laptop) type="Settings;HardwareSettings";;
900 office) type=Office;; 803 office) type=Office;;
901 pda) type=PDA;; 804 pda) type="Office;PDA";;
902 vim) type=TextEditor;; 805 vim) type="Development;TextEditor";;
903 xemacs) type=TextEditor;; 806 xemacs) type="Development;TextEditor";;
904 *) type=;;
905 esac 807 esac
906 ;; 808 ;;
907 809
908 dev) 810 dev)
909 type="Development" 811 type="Development"
910 ;; 812 ;;
911 813
912 games) 814 games)
913 case ${catmin} in 815 case ${catmin} in
914 action|fps) type=ActionGame;; 816 action|fps) type=ActionGame;;
915 arcade) type=ArcadeGame;; 817 arcade) type=ArcadeGame;;
916 board) type=BoardGame;; 818 board) type=BoardGame;;
917 emulation) type=Emulator;; 819 emulation) type=Emulator;;
918 kids) type=KidsGame;; 820 kids) type=KidsGame;;
919 puzzle) type=LogicGame;; 821 puzzle) type=LogicGame;;
920 roguelike) type=RolePlaying;; 822 roguelike) type=RolePlaying;;
921 rpg) type=RolePlaying;; 823 rpg) type=RolePlaying;;
922 simulation) type=Simulation;; 824 simulation) type=Simulation;;
923 sports) type=SportsGame;; 825 sports) type=SportsGame;;
924 strategy) type=StrategyGame;; 826 strategy) type=StrategyGame;;
925 *) type=;;
926 esac 827 esac
927 type="Game;${type}" 828 type="Game;${type}"
928 ;; 829 ;;
929 830
930 gnome) 831 gnome)
939 type="Network;Email" 840 type="Network;Email"
940 ;; 841 ;;
941 842
942 media) 843 media)
943 case ${catmin} in 844 case ${catmin} in
845 gfx)
944 gfx) type=Graphics;; 846 type=Graphics
847 ;;
848 *)
849 case ${catmin} in
945 radio) type=Tuner;; 850 radio) type=Tuner;;
946 sound) type=Audio;; 851 sound) type=Audio;;
947 tv) type=TV;; 852 tv) type=TV;;
948 video) type=Video;; 853 video) type=Video;;
949 *) type=;; 854 esac
855 type="AudioVideo;${type}"
856 ;;
950 esac 857 esac
951 type="AudioVideo;${type}"
952 ;; 858 ;;
953 859
954 net) 860 net)
955 case ${catmin} in 861 case ${catmin} in
956 dialup) type=Dialup;; 862 dialup) type=Dialup;;
957 ftp) type=FileTransfer;; 863 ftp) type=FileTransfer;;
958 im) type=InstantMessaging;; 864 im) type=InstantMessaging;;
959 irc) type=IRCClient;; 865 irc) type=IRCClient;;
960 mail) type=Email;; 866 mail) type=Email;;
961 news) type=News;; 867 news) type=News;;
962 nntp) type=News;; 868 nntp) type=News;;
963 p2p) type=FileTransfer;; 869 p2p) type=FileTransfer;;
964 *) type=;; 870 voip) type=Telephony;;
965 esac 871 esac
966 type="Network;${type}" 872 type="Network;${type}"
967 ;; 873 ;;
968 874
969 sci) 875 sci)
970 case ${catmin} in 876 case ${catmin} in
971 astro*) type=Astronomy;; 877 astro*) type=Astronomy;;
972 bio*) type=Biology;; 878 bio*) type=Biology;;
973 calc*) type=Calculator;; 879 calc*) type=Calculator;;
974 chem*) type=Chemistry;; 880 chem*) type=Chemistry;;
975 elec*) type=Electronics;; 881 elec*) type=Electronics;;
976 geo*) type=Geology;; 882 geo*) type=Geology;;
977 math*) type=Math;; 883 math*) type=Math;;
978 physics) type=Physics;; 884 physics) type=Physics;;
979 visual*) type=DataVisualization;; 885 visual*) type=DataVisualization;;
980 *) type=;;
981 esac 886 esac
982 type="Science;${type}" 887 type="Education;Science;${type}"
983 ;; 888 ;;
984 889
985 sys) 890 sys)
986 type="System" 891 type="System"
987 ;; 892 ;;
988 893
989 www) 894 www)
990 case ${catmin} in 895 case ${catmin} in
991 client) type=WebBrowser;; 896 client) type=WebBrowser;;
992 *) type=;;
993 esac 897 esac
994 type="Network" 898 type="Network;${type}"
995 ;; 899 ;;
996 900
997 *) 901 *)
998 type= 902 type=
999 ;; 903 ;;
1004 else 908 else
1005 local desktop_name="${PN}-${SLOT}" 909 local desktop_name="${PN}-${SLOT}"
1006 fi 910 fi
1007 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 911 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
1008 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 912 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
913
914 # Don't append another ";" when a valid category value is provided.
915 type=${type%;}${type:+;}
916
917 eshopts_push -s extglob
918 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
919 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
920 ewarn "allowed in .desktop files if the value is not an absolute path."
921 icon=${icon%.@(xpm|png|svg)}
922 fi
923 eshopts_pop
1009 924
1010 cat <<-EOF > "${desktop}" 925 cat <<-EOF > "${desktop}"
1011 [Desktop Entry] 926 [Desktop Entry]
1012 Name=${name} 927 Name=${name}
1013 Type=Application 928 Type=Application
1014 Comment=${DESCRIPTION} 929 Comment=${DESCRIPTION}
1015 Exec=${exec} 930 Exec=${exec}
1016 TryExec=${exec%% *} 931 TryExec=${exec%% *}
1017 Icon=${icon} 932 Icon=${icon}
1018 Categories=${type}; 933 Categories=${type}
1019 EOF 934 EOF
1020 935
1021 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 936 if [[ ${fields:-=} != *=* ]] ; then
937 # 5th arg used to be value to Path=
938 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
939 fields="Path=${fields}"
940 fi
941 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
1022 942
1023 ( 943 (
1024 # wrap the env here so that the 'insinto' call 944 # wrap the env here so that the 'insinto' call
1025 # doesn't corrupt the env of the caller 945 # doesn't corrupt the env of the caller
1026 insinto /usr/share/applications 946 insinto /usr/share/applications
1027 doins "${desktop}" 947 doins "${desktop}"
1028 ) 948 ) || die "installing desktop file failed"
949}
950
951# @FUNCTION: _eutils_eprefix_init
952# @INTERNAL
953# @DESCRIPTION:
954# Initialized prefix variables for EAPI<3.
955_eutils_eprefix_init() {
956 has "${EAPI:-0}" 0 1 2 && : ${ED:=${D}} ${EPREFIX:=} ${EROOT:=${ROOT}}
1029} 957}
1030 958
1031# @FUNCTION: validate_desktop_entries 959# @FUNCTION: validate_desktop_entries
1032# @USAGE: [directories] 960# @USAGE: [directories]
1033# @MAINTAINER: 961# @MAINTAINER:
1034# Carsten Lohrke <carlo@gentoo.org> 962# Carsten Lohrke <carlo@gentoo.org>
1035# @DESCRIPTION: 963# @DESCRIPTION:
1036# Validate desktop entries using desktop-file-utils 964# Validate desktop entries using desktop-file-utils
1037validate_desktop_entries() { 965validate_desktop_entries() {
966 _eutils_eprefix_init
1038 if [[ -x /usr/bin/desktop-file-validate ]] ; then 967 if [[ -x "${EPREFIX}"/usr/bin/desktop-file-validate ]] ; then
1039 einfo "Checking desktop entry validity" 968 einfo "Checking desktop entry validity"
1040 local directories="" 969 local directories=""
1041 for d in /usr/share/applications $@ ; do 970 for d in /usr/share/applications $@ ; do
1042 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}" 971 [[ -d ${ED}${d} ]] && directories="${directories} ${ED}${d}"
1043 done 972 done
1044 if [[ -n ${directories} ]] ; then 973 if [[ -n ${directories} ]] ; then
1045 for FILE in $(find ${directories} -name "*\.desktop" \ 974 for FILE in $(find ${directories} -name "*\.desktop" \
1046 -not -path '*.hidden*' | sort -u 2>/dev/null) 975 -not -path '*.hidden*' | sort -u 2>/dev/null)
1047 do 976 do
1048 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \ 977 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1049 sed -e "s|error: ||" -e "s|${FILE}:|--|g" ) 978 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1050 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:} 979 [[ -n $temp ]] && elog ${temp/--/${FILE/${ED}/}:}
1051 done 980 done
1052 fi 981 fi
1053 echo "" 982 echo ""
1054 else 983 else
1055 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 984 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1128 insinto /usr/share/applications 1057 insinto /usr/share/applications
1129 newins "$@" 1058 newins "$@"
1130 ) 1059 )
1131} 1060}
1132 1061
1133# @FUNCTION: doicon 1062# @FUNCTION: _iconins
1134# @USAGE: <list of icons> 1063# @INTERNAL
1135# @DESCRIPTION: 1064# @DESCRIPTION:
1136# Install the list of icons into the icon directory (/usr/share/pixmaps). 1065# function for use in doicon and newicon
1137# This is useful in conjunction with creating desktop/menu files. 1066_iconins() {
1138doicon() {
1139 ( 1067 (
1140 # wrap the env here so that the 'insinto' call 1068 # wrap the env here so that the 'insinto' call
1141 # doesn't corrupt the env of the caller 1069 # doesn't corrupt the env of the caller
1142 local i j ret 1070 local funcname=$1; shift
1143 insinto /usr/share/pixmaps 1071 local size dir
1144 for i in "$@" ; do 1072 local context=apps
1145 if [[ -f ${i} ]] ; then 1073 local theme=hicolor
1146 doins "${i}" 1074
1147 ((ret+=$?)) 1075 while [[ $# -gt 0 ]] ; do
1148 elif [[ -d ${i} ]] ; then 1076 case $1 in
1149 for j in "${i}"/*.png ; do 1077 -s|--size)
1150 doins "${j}" 1078 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1151 ((ret+=$?)) 1079 size=${2%%x*}
1152 done
1153 else 1080 else
1154 ((++ret)) 1081 size=${2}
1155 fi 1082 fi
1156 done
1157 exit ${ret}
1158 )
1159}
1160
1161# @FUNCTION: newicon
1162# @USAGE: <icon> <newname>
1163# @DESCRIPTION:
1164# Like all other new* functions, install the specified icon as newname.
1165newicon() {
1166 (
1167 # wrap the env here so that the 'insinto' call
1168 # doesn't corrupt the env of the caller
1169 insinto /usr/share/pixmaps
1170 newins "$@"
1171 )
1172}
1173
1174# for internal use only (unpack_pdv and unpack_makeself)
1175find_unpackable_file() {
1176 local src=$1
1177 if [[ -z ${src} ]] ; then
1178 src=${DISTDIR}/${A}
1179 else
1180 if [[ -e ${DISTDIR}/${src} ]] ; then
1181 src=${DISTDIR}/${src}
1182 elif [[ -e ${PWD}/${src} ]] ; then
1183 src=${PWD}/${src}
1184 elif [[ -e ${src} ]] ; then
1185 src=${src}
1186 fi
1187 fi
1188 [[ ! -e ${src} ]] && return 1
1189 echo "${src}"
1190}
1191
1192# @FUNCTION: unpack_pdv
1193# @USAGE: <file to unpack> <size of off_t>
1194# @DESCRIPTION:
1195# Unpack those pesky pdv generated files ...
1196# They're self-unpacking programs with the binary package stuffed in
1197# the middle of the archive. Valve seems to use it a lot ... too bad
1198# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1199#
1200# You have to specify the off_t size ... I have no idea how to extract that
1201# information out of the binary executable myself. Basically you pass in
1202# the size of the off_t type (in bytes) on the machine that built the pdv
1203# archive.
1204#
1205# One way to determine this is by running the following commands:
1206#
1207# @CODE
1208# strings <pdv archive> | grep lseek
1209# strace -elseek <pdv archive>
1210# @CODE
1211#
1212# Basically look for the first lseek command (we do the strings/grep because
1213# sometimes the function call is _llseek or something) and steal the 2nd
1214# parameter. Here is an example:
1215#
1216# @CODE
1217# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1218# lseek
1219# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1220# lseek(3, -4, SEEK_END) = 2981250
1221# @CODE
1222#
1223# Thus we would pass in the value of '4' as the second parameter.
1224unpack_pdv() {
1225 local src=$(find_unpackable_file "$1")
1226 local sizeoff_t=$2
1227
1228 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1229 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1230
1231 local shrtsrc=$(basename "${src}")
1232 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1233 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1234 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1235
1236 # grab metadata for debug reasons
1237 local metafile=$(emktemp)
1238 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1239
1240 # rip out the final file name from the metadata
1241 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1242 datafile=$(basename "${datafile}")
1243
1244 # now lets uncompress/untar the file if need be
1245 local tmpfile=$(emktemp)
1246 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1247
1248 local iscompressed=$(file -b "${tmpfile}")
1249 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1250 iscompressed=1
1251 mv ${tmpfile}{,.Z}
1252 gunzip ${tmpfile}
1253 else
1254 iscompressed=0
1255 fi
1256 local istar=$(file -b "${tmpfile}")
1257 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1258 istar=1
1259 else
1260 istar=0
1261 fi
1262
1263 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1264 #dd if=${src} ibs=${metaskip} count=1 \
1265 # | dd ibs=${tailskip} skip=1 \
1266 # | gzip -dc \
1267 # > ${datafile}
1268 if [ ${iscompressed} -eq 1 ] ; then
1269 if [ ${istar} -eq 1 ] ; then
1270 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1271 | head -c $((${metaskip}-${tailskip})) \
1272 | tar -xzf -
1273 else
1274 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1275 | head -c $((${metaskip}-${tailskip})) \
1276 | gzip -dc \
1277 > ${datafile}
1278 fi
1279 else
1280 if [ ${istar} -eq 1 ] ; then
1281 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1282 | head -c $((${metaskip}-${tailskip})) \
1283 | tar --no-same-owner -xf -
1284 else
1285 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1286 | head -c $((${metaskip}-${tailskip})) \
1287 > ${datafile}
1288 fi
1289 fi
1290 true
1291 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1292 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1293}
1294
1295# @FUNCTION: unpack_makeself
1296# @USAGE: [file to unpack] [offset] [tail|dd]
1297# @DESCRIPTION:
1298# Unpack those pesky makeself generated files ...
1299# They're shell scripts with the binary package tagged onto
1300# the end of the archive. Loki utilized the format as does
1301# many other game companies.
1302#
1303# If the file is not specified, then ${A} is used. If the
1304# offset is not specified then we will attempt to extract
1305# the proper offset from the script itself.
1306unpack_makeself() {
1307 local src_input=${1:-${A}}
1308 local src=$(find_unpackable_file "${src_input}")
1309 local skip=$2
1310 local exe=$3
1311
1312 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1313
1314 local shrtsrc=$(basename "${src}")
1315 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1316 if [[ -z ${skip} ]] ; then
1317 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1318 local skip=0
1319 exe=tail
1320 case ${ver} in 1083 case ${size} in
1321 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1084 16|22|24|32|36|48|64|72|96|128|192|256)
1322 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1085 size=${size}x${size};;
1323 ;; 1086 scalable)
1324 2.0|2.0.1)
1325 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1326 ;;
1327 2.1.1)
1328 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1329 let skip="skip + 1"
1330 ;;
1331 2.1.2)
1332 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1333 let skip="skip + 1"
1334 ;;
1335 2.1.3)
1336 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1337 let skip="skip + 1"
1338 ;;
1339 2.1.4|2.1.5)
1340 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1341 skip=$(head -n ${skip} "${src}" | wc -c)
1342 exe="dd"
1343 ;; 1087 ;;
1344 *) 1088 *)
1345 eerror "I'm sorry, but I was unable to support the Makeself file." 1089 eerror "${size} is an unsupported icon size!"
1346 eerror "The version I detected was '${ver}'." 1090 exit 1;;
1347 eerror "Please file a bug about the file ${shrtsrc} at"
1348 eerror "http://bugs.gentoo.org/ so that support can be added."
1349 die "makeself version '${ver}' not supported"
1350 ;;
1351 esac 1091 esac
1352 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1092 shift 2;;
1353 fi 1093 -t|--theme)
1354 case ${exe} in 1094 theme=${2}
1355 tail) exe="tail -n +${skip} '${src}'";; 1095 shift 2;;
1356 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1096 -c|--context)
1357 *) die "makeself cant handle exe '${exe}'" 1097 context=${2}
1358 esac 1098 shift 2;;
1359
1360 # lets grab the first few bytes of the file to figure out what kind of archive it is
1361 local tmpfile=$(emktemp)
1362 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1363 local filetype=$(file -b "${tmpfile}")
1364 case ${filetype} in
1365 *tar\ archive*)
1366 eval ${exe} | tar --no-same-owner -xf -
1367 ;;
1368 bzip2*)
1369 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1370 ;;
1371 gzip*)
1372 eval ${exe} | tar --no-same-owner -xzf -
1373 ;;
1374 compress*)
1375 eval ${exe} | gunzip | tar --no-same-owner -xf -
1376 ;;
1377 *) 1099 *)
1378 eerror "Unknown filetype \"${filetype}\" ?"
1379 false
1380 ;;
1381 esac
1382 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1383}
1384
1385# @FUNCTION: check_license
1386# @USAGE: [license]
1387# @DESCRIPTION:
1388# Display a license for user to accept. If no license is
1389# specified, then ${LICENSE} is used.
1390check_license() {
1391 local lic=$1
1392 if [ -z "${lic}" ] ; then
1393 lic="${PORTDIR}/licenses/${LICENSE}"
1394 else
1395 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1396 lic="${PORTDIR}/licenses/${lic}"
1397 elif [ -e "${PWD}/${lic}" ] ; then
1398 lic="${PWD}/${lic}"
1399 elif [ -e "${lic}" ] ; then
1400 lic="${lic}"
1401 fi
1402 fi
1403 local l="`basename ${lic}`"
1404
1405 # here is where we check for the licenses the user already
1406 # accepted ... if we don't find a match, we make the user accept
1407 local alic
1408 eshopts_push -o noglob # so that bash doesn't expand "*"
1409 for alic in ${ACCEPT_LICENSE} ; do
1410 if [[ ${alic} == ${l} ]]; then
1411 eshopts_pop
1412 return 0
1413 fi
1414 done
1415 eshopts_pop
1416 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1417
1418 local licmsg=$(emktemp)
1419 cat <<-EOF > ${licmsg}
1420 **********************************************************
1421 The following license outlines the terms of use of this
1422 package. You MUST accept this license for installation to
1423 continue. When you are done viewing, hit 'q'. If you
1424 CTRL+C out of this, the install will not run!
1425 **********************************************************
1426
1427 EOF
1428 cat ${lic} >> ${licmsg}
1429 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1430 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1431 read alic
1432 case ${alic} in
1433 yes|Yes|y|Y)
1434 return 0
1435 ;;
1436 *)
1437 echo;echo;echo
1438 eerror "You MUST accept the license to continue! Exiting!"
1439 die "Failed to accept license"
1440 ;;
1441 esac
1442}
1443
1444# @FUNCTION: cdrom_get_cds
1445# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1446# @DESCRIPTION:
1447# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1448# the whole 'non-interactive' policy, but damnit I want CD support !
1449#
1450# With these cdrom functions we handle all the user interaction and
1451# standardize everything. All you have to do is call cdrom_get_cds()
1452# and when the function returns, you can assume that the cd has been
1453# found at CDROM_ROOT.
1454#
1455# The function will attempt to locate a cd based upon a file that is on
1456# the cd. The more files you give this function, the more cds
1457# the cdrom functions will handle.
1458#
1459# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1460# etc... If you want to give the cds better names, then just export
1461# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1462# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1463# also use the CDROM_NAME_SET bash array.
1464#
1465# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1466cdrom_get_cds() {
1467 # first we figure out how many cds we're dealing with by
1468 # the # of files they gave us
1469 local cdcnt=0
1470 local f=
1471 for f in "$@" ; do
1472 ((++cdcnt))
1473 export CDROM_CHECK_${cdcnt}="$f"
1474 done
1475 export CDROM_TOTAL_CDS=${cdcnt}
1476 export CDROM_CURRENT_CD=1
1477
1478 # now we see if the user gave use CD_ROOT ...
1479 # if they did, let's just believe them that it's correct
1480 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1481 local var=
1482 cdcnt=0
1483 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1484 ((++cdcnt))
1485 var="CD_ROOT_${cdcnt}"
1486 [[ -z ${!var} ]] && var="CD_ROOT"
1487 if [[ -z ${!var} ]] ; then 1100 if [[ -z ${size} ]] ; then
1488 eerror "You must either use just the CD_ROOT" 1101 insinto /usr/share/pixmaps
1489 eerror "or specify ALL the CD_ROOT_X variables." 1102 else
1490 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1103 insinto /usr/share/icons/${theme}/${size}/${context}
1491 die "could not locate CD_ROOT_${cdcnt}"
1492 fi 1104 fi
1493 done
1494 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1495 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1496 export CDROM_SET=-1
1497 for f in ${CDROM_CHECK_1//:/ } ; do
1498 ((++CDROM_SET))
1499 [[ -e ${CD_ROOT}/${f} ]] && break
1500 done
1501 export CDROM_MATCH=${f}
1502 return
1503 fi
1504 1105
1505 # User didn't help us out so lets make sure they know they can 1106 if [[ ${funcname} == doicon ]] ; then
1506 # simplify the whole process ...
1507 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1508 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1509 echo
1510 einfo "If you do not have the CD, but have the data files"
1511 einfo "mounted somewhere on your filesystem, just export"
1512 einfo "the variable CD_ROOT so that it points to the"
1513 einfo "directory containing the files."
1514 echo
1515 einfo "For example:"
1516 einfo "export CD_ROOT=/mnt/cdrom"
1517 echo
1518 else
1519 if [[ -n ${CDROM_NAME_SET} ]] ; then
1520 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1521 cdcnt=0
1522 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1523 ((++cdcnt))
1524 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1525 done
1526 fi
1527
1528 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1529 cdcnt=0
1530 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1531 ((++cdcnt))
1532 var="CDROM_NAME_${cdcnt}"
1533 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1534 done
1535 echo
1536 einfo "If you do not have the CDs, but have the data files"
1537 einfo "mounted somewhere on your filesystem, just export"
1538 einfo "the following variables so they point to the right place:"
1539 einfon ""
1540 cdcnt=0
1541 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1542 ((++cdcnt))
1543 echo -n " CD_ROOT_${cdcnt}"
1544 done
1545 echo
1546 einfo "Or, if you have all the files in the same place, or"
1547 einfo "you only have one cdrom, you can export CD_ROOT"
1548 einfo "and that place will be used as the same data source"
1549 einfo "for all the CDs."
1550 echo
1551 einfo "For example:"
1552 einfo "export CD_ROOT_1=/mnt/cdrom"
1553 echo
1554 fi
1555
1556 export CDROM_SET=""
1557 export CDROM_CURRENT_CD=0
1558 cdrom_load_next_cd
1559}
1560
1561# @FUNCTION: cdrom_load_next_cd
1562# @DESCRIPTION:
1563# Some packages are so big they come on multiple CDs. When you're done reading
1564# files off a CD and want access to the next one, just call this function.
1565# Again, all the messy details of user interaction are taken care of for you.
1566# Once this returns, just read the variable CDROM_ROOT for the location of the
1567# mounted CD. Note that you can only go forward in the CD list, so make sure
1568# you only call this function when you're done using the current CD.
1569cdrom_load_next_cd() {
1570 local var
1571 ((++CDROM_CURRENT_CD))
1572
1573 unset CDROM_ROOT
1574 var=CD_ROOT_${CDROM_CURRENT_CD}
1575 [[ -z ${!var} ]] && var="CD_ROOT"
1576 if [[ -z ${!var} ]] ; then 1107 if [[ -f $1 ]] ; then
1577 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1108 doins "${1}"
1578 _cdrom_locate_file_on_cd ${!var} 1109 elif [[ -d $1 ]] ; then
1579 else 1110 shopt -s nullglob
1580 export CDROM_ROOT=${!var} 1111 doins "${1}"/*.{png,svg}
1581 fi 1112 shopt -u nullglob
1582
1583 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1584}
1585
1586# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1587# functions. this should *never* be called from an ebuild.
1588# all it does is try to locate a give file on a cd ... if the cd isn't
1589# found, then a message asking for the user to insert the cdrom will be
1590# displayed and we'll hang out here until:
1591# (1) the file is found on a mounted cdrom
1592# (2) the user hits CTRL+C
1593_cdrom_locate_file_on_cd() {
1594 local mline=""
1595 local showedmsg=0 showjolietmsg=0
1596
1597 while [[ -z ${CDROM_ROOT} ]] ; do
1598 local i=0
1599 local -a cdset=(${*//:/ })
1600 if [[ -n ${CDROM_SET} ]] ; then
1601 cdset=(${cdset[${CDROM_SET}]})
1602 fi
1603
1604 while [[ -n ${cdset[${i}]} ]] ; do
1605 local dir=$(dirname ${cdset[${i}]})
1606 local file=$(basename ${cdset[${i}]})
1607
1608 local point= node= fs= foo=
1609 while read point node fs foo ; do
1610 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1611 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1612 && continue
1613 point=${point//\040/ }
1614 [[ ! -d ${point}/${dir} ]] && continue
1615 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1616 export CDROM_ROOT=${point}
1617 export CDROM_SET=${i}
1618 export CDROM_MATCH=${cdset[${i}]}
1619 return
1620 done <<< "$(get_mounts)"
1621
1622 ((++i))
1623 done
1624
1625 echo
1626 if [[ ${showedmsg} -eq 0 ]] ; then
1627 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1628 if [[ -z ${CDROM_NAME} ]] ; then
1629 einfo "Please insert+mount the cdrom for ${PN} now !"
1630 else 1113 else
1631 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !" 1114 eerror "${1} is not a valid file/directory!"
1115 exit 1
1632 fi 1116 fi
1633 else 1117 else
1634 if [[ -z ${CDROM_NAME_1} ]] ; then 1118 break
1635 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1636 else
1637 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1638 einfo "Please insert+mount the ${!var} cdrom now !"
1639 fi
1640 fi 1119 fi
1641 showedmsg=1 1120 shift 1;;
1642 fi 1121 esac
1643 einfo "Press return to scan for the cd again"
1644 einfo "or hit CTRL+C to abort the emerge."
1645 echo
1646 if [[ ${showjolietmsg} -eq 0 ]] ; then
1647 showjolietmsg=1
1648 else
1649 ewarn "If you are having trouble with the detection"
1650 ewarn "of your CD, it is possible that you do not have"
1651 ewarn "Joliet support enabled in your kernel. Please"
1652 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1653 ebeep 5
1654 fi
1655 read || die "something is screwed with your system"
1656 done 1122 done
1123 if [[ ${funcname} == newicon ]] ; then
1124 newins "$@"
1125 fi
1126 ) || die
1127}
1128
1129# @FUNCTION: doicon
1130# @USAGE: [options] <icons>
1131# @DESCRIPTION:
1132# Install icon into the icon directory /usr/share/icons or into
1133# /usr/share/pixmaps if "--size" is not set.
1134# This is useful in conjunction with creating desktop/menu files.
1135#
1136# @CODE
1137# options:
1138# -s, --size
1139# !!! must specify to install into /usr/share/icons/... !!!
1140# size of the icon, like 48 or 48x48
1141# supported icon sizes are:
1142# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1143# -c, --context
1144# defaults to "apps"
1145# -t, --theme
1146# defaults to "hicolor"
1147#
1148# icons: list of icons
1149#
1150# example 1: doicon foobar.png fuqbar.svg suckbar.png
1151# results in: insinto /usr/share/pixmaps
1152# doins foobar.png fuqbar.svg suckbar.png
1153#
1154# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1155# results in: insinto /usr/share/icons/hicolor/48x48/apps
1156# doins foobar.png fuqbar.png blobbar.png
1157# @CODE
1158doicon() {
1159 _iconins ${FUNCNAME} "$@"
1160}
1161
1162# @FUNCTION: newicon
1163# @USAGE: [options] <icon> <newname>
1164# @DESCRIPTION:
1165# Like doicon, install the specified icon as newname.
1166#
1167# @CODE
1168# example 1: newicon foobar.png NEWNAME.png
1169# results in: insinto /usr/share/pixmaps
1170# newins foobar.png NEWNAME.png
1171#
1172# example 2: newicon -s 48 foobar.png NEWNAME.png
1173# results in: insinto /usr/share/icons/hicolor/48x48/apps
1174# newins foobar.png NEWNAME.png
1175# @CODE
1176newicon() {
1177 _iconins ${FUNCNAME} "$@"
1657} 1178}
1658 1179
1659# @FUNCTION: strip-linguas 1180# @FUNCTION: strip-linguas
1660# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>] 1181# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1661# @DESCRIPTION: 1182# @DESCRIPTION:
1678 else 1199 else
1679 newls="" 1200 newls=""
1680 fi 1201 fi
1681 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do 1202 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1682 if [[ ${op} == "-i" ]] ; then 1203 if [[ ${op} == "-i" ]] ; then
1683 hasq ${f} ${ls} && newls="${newls} ${f}" 1204 has ${f} ${ls} && newls="${newls} ${f}"
1684 else 1205 else
1685 hasq ${f} ${ls} || newls="${newls} ${f}" 1206 has ${f} ${ls} || newls="${newls} ${f}"
1686 fi 1207 fi
1687 done 1208 done
1688 ls=${newls} 1209 ls=${newls}
1689 done 1210 done
1690 else 1211 else
1692 fi 1213 fi
1693 1214
1694 nols="" 1215 nols=""
1695 newls="" 1216 newls=""
1696 for f in ${LINGUAS} ; do 1217 for f in ${LINGUAS} ; do
1697 if hasq ${f} ${ls} ; then 1218 if has ${f} ${ls} ; then
1698 newls="${newls} ${f}" 1219 newls="${newls} ${f}"
1699 else 1220 else
1700 nols="${nols} ${f}" 1221 nols="${nols} ${f}"
1701 fi 1222 fi
1702 done 1223 done
1703 [[ -n ${nols} ]] \ 1224 [[ -n ${nols} ]] \
1704 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols} 1225 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1705 export LINGUAS=${newls:1} 1226 export LINGUAS=${newls:1}
1706} 1227}
1707 1228
1708# @FUNCTION: preserve_old_lib 1229# @FUNCTION: preserve_old_lib
1709# @USAGE: <libs to preserve> [more libs] 1230# @USAGE: <libs to preserve> [more libs]
1713# would break packages that link against it. Most people get around this 1234# would break packages that link against it. Most people get around this
1714# by using the portage SLOT mechanism, but that is not always a relevant 1235# by using the portage SLOT mechanism, but that is not always a relevant
1715# solution, so instead you can call this from pkg_preinst. See also the 1236# solution, so instead you can call this from pkg_preinst. See also the
1716# preserve_old_lib_notify function. 1237# preserve_old_lib_notify function.
1717preserve_old_lib() { 1238preserve_old_lib() {
1239 _eutils_eprefix_init
1718 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then 1240 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1719 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1241 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1720 die "Invalid preserve_old_lib() usage" 1242 die "Invalid preserve_old_lib() usage"
1721 fi 1243 fi
1722 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1244 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1724 # let portage worry about it 1246 # let portage worry about it
1725 has preserve-libs ${FEATURES} && return 0 1247 has preserve-libs ${FEATURES} && return 0
1726 1248
1727 local lib dir 1249 local lib dir
1728 for lib in "$@" ; do 1250 for lib in "$@" ; do
1729 [[ -e ${ROOT}/${lib} ]] || continue 1251 [[ -e ${EROOT}/${lib} ]] || continue
1730 dir=${lib%/*} 1252 dir=${lib%/*}
1731 dodir ${dir} || die "dodir ${dir} failed" 1253 dodir ${dir} || die "dodir ${dir} failed"
1732 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed" 1254 cp "${EROOT}"/${lib} "${ED}"/${lib} || die "cp ${lib} failed"
1733 touch "${D}"/${lib} 1255 touch "${ED}"/${lib}
1734 done 1256 done
1735} 1257}
1736 1258
1737# @FUNCTION: preserve_old_lib_notify 1259# @FUNCTION: preserve_old_lib_notify
1738# @USAGE: <libs to notify> [more libs] 1260# @USAGE: <libs to notify> [more libs]
1745 fi 1267 fi
1746 1268
1747 # let portage worry about it 1269 # let portage worry about it
1748 has preserve-libs ${FEATURES} && return 0 1270 has preserve-libs ${FEATURES} && return 0
1749 1271
1272 _eutils_eprefix_init
1273
1750 local lib notice=0 1274 local lib notice=0
1751 for lib in "$@" ; do 1275 for lib in "$@" ; do
1752 [[ -e ${ROOT}/${lib} ]] || continue 1276 [[ -e ${EROOT}/${lib} ]] || continue
1753 if [[ ${notice} -eq 0 ]] ; then 1277 if [[ ${notice} -eq 0 ]] ; then
1754 notice=1 1278 notice=1
1755 ewarn "Old versions of installed libraries were detected on your system." 1279 ewarn "Old versions of installed libraries were detected on your system."
1756 ewarn "In order to avoid breaking packages that depend on these old libs," 1280 ewarn "In order to avoid breaking packages that depend on these old libs,"
1757 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1281 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1758 ewarn "in order to remove these old dependencies. If you do not have this" 1282 ewarn "in order to remove these old dependencies. If you do not have this"
1759 ewarn "helper program, simply emerge the 'gentoolkit' package." 1283 ewarn "helper program, simply emerge the 'gentoolkit' package."
1760 ewarn 1284 ewarn
1761 fi 1285 fi
1762 ewarn " # revdep-rebuild --library ${lib##*/}" 1286 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1763 done 1287 done
1764 if [[ ${notice} -eq 1 ]] ; then
1765 ewarn
1766 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1767 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1768 for lib in "$@" ; do
1769 ewarn " # rm '${lib}'"
1770 done
1771 fi
1772} 1288}
1773 1289
1774# @FUNCTION: built_with_use 1290# @FUNCTION: built_with_use
1775# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1291# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1776# @DESCRIPTION: 1292# @DESCRIPTION:
1791# in IUSE like normal USE flags. 1307# in IUSE like normal USE flags.
1792# 1308#
1793# Remember that this function isn't terribly intelligent so order of optional 1309# Remember that this function isn't terribly intelligent so order of optional
1794# flags matter. 1310# flags matter.
1795built_with_use() { 1311built_with_use() {
1312 _eutils_eprefix_init
1796 local hidden="no" 1313 local hidden="no"
1797 if [[ $1 == "--hidden" ]] ; then 1314 if [[ $1 == "--hidden" ]] ; then
1798 hidden="yes" 1315 hidden="yes"
1799 shift 1316 shift
1800 fi 1317 fi
1814 1331
1815 local PKG=$(best_version $1) 1332 local PKG=$(best_version $1)
1816 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package" 1333 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1817 shift 1334 shift
1818 1335
1819 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1336 local USEFILE=${EROOT}/var/db/pkg/${PKG}/USE
1820 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE 1337 local IUSEFILE=${EROOT}/var/db/pkg/${PKG}/IUSE
1821 1338
1822 # if the IUSE file doesn't exist, the read will error out, we need to handle 1339 # if the IUSE file doesn't exist, the read will error out, we need to handle
1823 # this gracefully 1340 # this gracefully
1824 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then 1341 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1825 case ${missing_action} in 1342 case ${missing_action} in
1871# http://bugs.gentoo.org/73450 1388# http://bugs.gentoo.org/73450
1872epunt_cxx() { 1389epunt_cxx() {
1873 local dir=$1 1390 local dir=$1
1874 [[ -z ${dir} ]] && dir=${S} 1391 [[ -z ${dir} ]] && dir=${S}
1875 ebegin "Removing useless C++ checks" 1392 ebegin "Removing useless C++ checks"
1876 local f 1393 local f p any_found
1877 find "${dir}" -name configure | while read f ; do 1394 while IFS= read -r -d '' f; do
1878 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1395 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1396 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1397 any_found=1
1398 break
1399 fi
1879 done 1400 done
1401 done < <(find "${dir}" -name configure -print0)
1402
1403 if [[ -z ${any_found} ]]; then
1404 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1405 fi
1880 eend 0 1406 eend 0
1881} 1407}
1882 1408
1883# @FUNCTION: make_wrapper 1409# @FUNCTION: make_wrapper
1884# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath] 1410# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1886# Create a shell wrapper script named wrapper in installpath 1412# Create a shell wrapper script named wrapper in installpath
1887# (defaults to the bindir) to execute target (default of wrapper) by 1413# (defaults to the bindir) to execute target (default of wrapper) by
1888# first optionally setting LD_LIBRARY_PATH to the colon-delimited 1414# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1889# libpaths followed by optionally changing directory to chdir. 1415# libpaths followed by optionally changing directory to chdir.
1890make_wrapper() { 1416make_wrapper() {
1417 _eutils_eprefix_init
1891 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1418 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1892 local tmpwrapper=$(emktemp) 1419 local tmpwrapper=$(emktemp)
1420
1421 (
1422 echo '#!/bin/sh'
1423 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${EPREFIX}${chdir}"
1424 if [[ -n ${libdir} ]] ; then
1425 local var
1426 if [[ ${CHOST} == *-darwin* ]] ; then
1427 var=DYLD_LIBRARY_PATH
1428 else
1429 var=LD_LIBRARY_PATH
1430 fi
1431 cat <<-EOF
1432 if [ "\${${var}+set}" = "set" ] ; then
1433 export ${var}="\${${var}}:${EPREFIX}${libdir}"
1434 else
1435 export ${var}="${EPREFIX}${libdir}"
1436 fi
1437 EOF
1438 fi
1893 # We don't want to quote ${bin} so that people can pass complex 1439 # We don't want to quote ${bin} so that people can pass complex
1894 # things as $bin ... "./someprog --args" 1440 # things as ${bin} ... "./someprog --args"
1441 printf 'exec %s "$@"\n' "${bin/#\//${EPREFIX}\/}"
1895 cat << EOF > "${tmpwrapper}" 1442 ) > "${tmpwrapper}"
1896#!/bin/sh
1897cd "${chdir:-.}"
1898if [ -n "${libdir}" ] ; then
1899 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1900 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1901 else
1902 export LD_LIBRARY_PATH="${libdir}"
1903 fi
1904fi
1905exec ${bin} "\$@"
1906EOF
1907 chmod go+rx "${tmpwrapper}" 1443 chmod go+rx "${tmpwrapper}"
1444
1908 if [[ -n ${path} ]] ; then 1445 if [[ -n ${path} ]] ; then
1909 ( 1446 (
1910 exeinto "${path}" 1447 exeinto "${path}"
1911 newexe "${tmpwrapper}" "${wrapper}" 1448 newexe "${tmpwrapper}" "${wrapper}"
1912 ) || die 1449 ) || die
1913 else 1450 else
1914 newbin "${tmpwrapper}" "${wrapper}" || die 1451 newbin "${tmpwrapper}" "${wrapper}" || die
1915 fi 1452 fi
1916} 1453}
1917 1454
1918# @FUNCTION: prepalldocs 1455# @FUNCTION: path_exists
1919# @USAGE: 1456# @USAGE: [-a|-o] <paths>
1920# @DESCRIPTION: 1457# @DESCRIPTION:
1921# Compress files in /usr/share/doc which are not already 1458# Check if the specified paths exist. Works for all types of paths
1922# compressed, excluding /usr/share/doc/${PF}/html. 1459# (files/dirs/etc...). The -a and -o flags control the requirements
1923# Uses the ecompressdir to do the compression. 1460# of the paths. They correspond to "and" and "or" logic. So the -a
1924# 2009-02-18 by betelgeuse: 1461# flag means all the paths must exist while the -o flag means at least
1925# Commented because ecompressdir is even more internal to 1462# one of the paths must exist. The default behavior is "and". If no
1926# Portage than prepalldocs (it's not even mentioned in man 5 1463# paths are specified, then the return value is "false".
1927# ebuild). Please submit a better version for review to gentoo-dev 1464path_exists() {
1928# if you want prepalldocs here. 1465 local opt=$1
1929#prepalldocs() { 1466 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1930# if [[ -n $1 ]] ; then 1467
1931# ewarn "prepalldocs: invalid usage; takes no arguments" 1468 # no paths -> return false
1469 # same behavior as: [[ -e "" ]]
1470 [[ $# -eq 0 ]] && return 1
1471
1472 local p r=0
1473 for p in "$@" ; do
1474 [[ -e ${p} ]]
1475 : $(( r += $? ))
1476 done
1477
1478 case ${opt} in
1479 -a) return $(( r != 0 )) ;;
1480 -o) return $(( r == $# )) ;;
1481 esac
1482}
1483
1484# @FUNCTION: in_iuse
1485# @USAGE: <flag>
1486# @DESCRIPTION:
1487# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1488# as necessary.
1489#
1490# Note that this function should not be used in the global scope.
1491in_iuse() {
1492 debug-print-function ${FUNCNAME} "${@}"
1493 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1494
1495 local flag=${1}
1496 local liuse=( ${IUSE} )
1497
1498 has "${flag}" "${liuse[@]#[+-]}"
1499}
1500
1501# @FUNCTION: use_if_iuse
1502# @USAGE: <flag>
1503# @DESCRIPTION:
1504# Return true if the given flag is in USE and IUSE.
1505#
1506# Note that this function should not be used in the global scope.
1507use_if_iuse() {
1508 in_iuse $1 || return 1
1509 use $1
1510}
1511
1512# @FUNCTION: usex
1513# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1514# @DESCRIPTION:
1515# Proxy to declare usex for package managers or EAPIs that do not provide it
1516# and use the package manager implementation when available (i.e. EAPI >= 5).
1517# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1518# otherwise echo [false output][false suffix] (defaults to "no").
1519if has "${EAPI:-0}" 0 1 2 3 4; then
1520 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1521fi
1522
1523# @FUNCTION: prune_libtool_files
1524# @USAGE: [--all|--modules]
1525# @DESCRIPTION:
1526# Locate unnecessary libtool files (.la) and libtool static archives
1527# (.a) and remove them from installation image.
1528#
1529# By default, .la files are removed whenever the static linkage can
1530# either be performed using pkg-config or doesn't introduce additional
1531# flags.
1532#
1533# If '--modules' argument is passed, .la files for modules (plugins) are
1534# removed as well. This is usually useful when the package installs
1535# plugins and the plugin loader does not use .la files.
1536#
1537# If '--all' argument is passed, all .la files are removed without
1538# performing any heuristic on them. You shouldn't ever use that,
1539# and instead report a bug in the algorithm instead.
1540#
1541# The .a files are only removed whenever corresponding .la files state
1542# that they should not be linked to, i.e. whenever these files
1543# correspond to plugins.
1544#
1545# Note: if your package installs both static libraries and .pc files
1546# which use variable substitution for -l flags, you need to add
1547# pkg-config to your DEPEND.
1548prune_libtool_files() {
1549 debug-print-function ${FUNCNAME} "$@"
1550
1551 local removing_all removing_modules opt
1552 _eutils_eprefix_init
1553 for opt; do
1554 case "${opt}" in
1555 --all)
1556 removing_all=1
1557 removing_modules=1
1558 ;;
1559 --modules)
1560 removing_modules=1
1561 ;;
1562 *)
1563 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1564 esac
1565 done
1566
1567 local f
1568 local queue=()
1569 while IFS= read -r -d '' f; do # for all .la files
1570 local archivefile=${f/%.la/.a}
1571
1572 # The following check is done by libtool itself.
1573 # It helps us avoid removing random files which match '*.la',
1574 # see bug #468380.
1575 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1' "${f}"; then
1576 continue
1577 fi
1578
1579 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1580 local reason pkgconfig_scanned
1581 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1582
1583 if [[ ${snotlink} == yes ]]; then
1584
1585 # Remove static libs we're not supposed to link against.
1586 if [[ -f ${archivefile} ]]; then
1587 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1588 queue+=( "${archivefile}" )
1589 fi
1590
1591 # The .la file may be used by a module loader, so avoid removing it
1592 # unless explicitly requested.
1593 if [[ ${removing_modules} ]]; then
1594 reason='module'
1595 fi
1596
1597 else
1598
1599 # Remove .la files when:
1600 # - user explicitly wants us to remove all .la files,
1601 # - respective static archive doesn't exist,
1602 # - they are covered by a .pc file already,
1603 # - they don't provide any new information (no libs & no flags).
1604
1605 if [[ ${removing_all} ]]; then
1606 reason='requested'
1607 elif [[ ! -f ${archivefile} ]]; then
1608 reason='no static archive'
1609 elif [[ ! $(sed -nre \
1610 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1611 "${f}") ]]; then
1612 reason='no libs & flags'
1613 else
1614 if [[ ! ${pkgconfig_scanned} ]]; then
1615 # Create a list of all .pc-covered libs.
1616 local pc_libs=()
1617 if [[ ! ${removing_all} ]]; then
1618 local pc
1619 local tf=${T}/prune-lt-files.pc
1620 local pkgconf=$(tc-getPKG_CONFIG)
1621
1622 while IFS= read -r -d '' pc; do # for all .pc files
1623 local arg libs
1624
1625 # Use pkg-config if available (and works),
1626 # fallback to sed.
1627 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1628 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1629 libs=$(${pkgconf} --libs "${tf}")
1630 else
1631 libs=$(sed -ne 's/^Libs://p' "${pc}")
1632 fi
1633
1634 for arg in ${libs}; do
1635 if [[ ${arg} == -l* ]]; then
1636 if [[ ${arg} == '*$*' ]]; then
1637 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1638 eqawarn "(arg: ${arg})"
1639 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1640 fi
1641
1642 pc_libs+=( lib${arg#-l}.la )
1643 fi
1644 done
1645 done < <(find "${D}" -type f -name '*.pc' -print0)
1646
1647 rm -f "${tf}"
1648 fi
1649
1650 pkgconfig_scanned=1
1651 fi # pkgconfig_scanned
1652
1653 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1654 fi # removal due to .pc
1655
1656 fi # shouldnotlink==no
1657
1658 if [[ ${reason} ]]; then
1659 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1660 queue+=( "${f}" )
1661 fi
1662 done < <(find "${ED}" -xtype f -name '*.la' -print0)
1663
1664 if [[ ${queue[@]} ]]; then
1665 rm -f "${queue[@]}"
1932# fi 1666 fi
1667}
1933 1668
1934# cd "${D}" 1669einstalldocs() {
1935# [[ -d usr/share/doc ]] || return 0 1670 debug-print-function ${FUNCNAME} "${@}"
1936 1671
1937# find usr/share/doc -exec gzip {} + 1672 local dodoc_opts=-r
1938# ecompressdir --ignore /usr/share/doc/${PF}/html 1673 has ${EAPI} 0 1 2 3 && dodoc_opts=
1939# ecompressdir --queue /usr/share/doc 1674
1940#} 1675 if ! declare -p DOCS &>/dev/null ; then
1676 local d
1677 for d in README* ChangeLog AUTHORS NEWS TODO CHANGES \
1678 THANKS BUGS FAQ CREDITS CHANGELOG ; do
1679 if [[ -s ${d} ]] ; then
1680 dodoc "${d}" || die
1681 fi
1682 done
1683 elif [[ $(declare -p DOCS) == "declare -a"* ]] ; then
1684 if [[ ${DOCS[@]} ]] ; then
1685 dodoc ${dodoc_opts} "${DOCS[@]}" || die
1686 fi
1687 else
1688 if [[ ${DOCS} ]] ; then
1689 dodoc ${dodoc_opts} ${DOCS} || die
1690 fi
1691 fi
1692
1693 if [[ $(declare -p HTML_DOCS 2>/dev/null) == "declare -a"* ]] ; then
1694 if [[ ${HTML_DOCS[@]} ]] ; then
1695 dohtml -r "${HTML_DOCS[@]}" || die
1696 fi
1697 else
1698 if [[ ${HTML_DOCS} ]] ; then
1699 dohtml -r ${HTML_DOCS} || die
1700 fi
1701 fi
1702
1703 return 0
1704}
1705
1706check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1707
1708fi

Legend:
Removed from v.1.335  
changed lines
  Added in v.1.428

  ViewVC Help
Powered by ViewVC 1.1.20